import { ElementRef, OnInit, EventEmitter } from '@angular/core';
import { DomHandler } from '../dom/domhandler';
import { ControlValueAccessor } from '@angular/forms';
export declare const SPINNER_VALUE_ACCESSOR: any;
export declare class Spinner implements OnInit, ControlValueAccessor {
    el: ElementRef;
    domHandler: DomHandler;
    onChange: EventEmitter<any>;
    onFocus: EventEmitter<any>;
    onBlur: EventEmitter<any>;
    step: number;
    min: number;
    max: number;
    maxlength: number;
    size: number;
    placeholder: string;
    inputId: string;
    disabled: boolean;
    readonly: boolean;
    tabindex: number;
    type: string;
    required: boolean;
    name: string;
    inputStyle: any;
    inputStyleClass: string;
    value: any;
    onModelChange: Function;
    onModelTouched: Function;
    keyPattern: RegExp;
    precision: number;
    timer: any;
    focus: boolean;
    filled: boolean;
    negativeSeparator: string;
    inputfieldViewChild: ElementRef;
    constructor(el: ElementRef, domHandler: DomHandler);
    decimalSeparator: string;
    thousandSeparator: string;
    formatInput: boolean;
    ngOnInit(): void;
    repeat(event: Event, interval: number, dir: number): void;
    spin(event: Event, dir: number): void;
    toFixed(value: number, precision: number): string;
    onUpButtonMousedown(event: Event): void;
    onUpButtonMouseup(event: Event): void;
    onUpButtonMouseleave(event: Event): void;
    onDownButtonMousedown(event: Event): void;
    onDownButtonMouseup(event: Event): void;
    onDownButtonMouseleave(event: Event): void;
    onInputKeydown(event: KeyboardEvent): void;
    onInputChange(event: Event): void;
    onInput(event: KeyboardEvent): void;
    onInputBlur(event: any): void;
    onInputFocus(event: any): void;
    parseValue(val: string): number;
    clearTimer(): void;
    writeValue(value: any): void;
    registerOnChange(fn: Function): void;
    registerOnTouched(fn: Function): void;
    setDisabledState(val: boolean): void;
    updateFilledState(): void;
}
export declare class SpinnerModule {
}
